<#
.SYNOPSIS
    A short one-line action-based description, e.g. 'Tests if a function is valid'
.DESCRIPTION
    A longer description of the function, its purpose, common use cases, etc.
.NOTES
    Information or caveats about the function e.g. 'This function is not supported in Linux'
.LINK
    Specify a URI to a help page, this will show when Get-Help -Online is used.
.EXAMPLE
    Test-MyTestFunction -Verbose
    Explanation of the function or its result. You can include multiple examples with additional .EXAMPLE lines
#>

function Get-ITDServiceNowUser {
    [CmdletBinding()]
    param (
        [Parameter(ParameterSetName = 'Email')]
        [string]
        $Email,

        [Parameter(ParameterSetName = 'Username')]
        [string]
        $Username,

        [Parameter(ParameterSetName = 'SysId')]
        [string]
        $SysId
    )
    
    begin {
        
    }
    
    process {
        $Query = "?sysparm_query="
        If ($Email) { $Query += "email=$Email" }
        If ($UserName) { $Query += "user_name=$Username" }
        If ($SysId) { $Query += "sys_id=$SysId" }
        
        $InvokeRestMethodParams = @{
            Method      = 'Get';
            Uri         = ($Script:ServiceNowSession.Uri + "/api/now/table/sys_user" + $Query + "&sysparm_limit=10");
            Headers     = $Script:ServiceNowSession.Headers;
            ContentType = $Script:ServiceNowSession.ContentType;
        }
        
        Write-Verbose $InvokeRestMethodParams.Uri

        $Result = Invoke-RestMethod @InvokeRestMethodParams
    }
    
    end {
        Write-Output $Result.result
    }
}